import cv2 as cv


def main(image):
    global src
    src = cv.imread(cv.samples.findFile(image))
    if src is None:
        print("Could not open or find the image: ", image)
        exit(0)
    cv.namedWindow(title_erosion_window)
    cv.createTrackbar(
        title_trackbar_element_shape, title_erosion_window, 0, max_elem, erosion
    )
    cv.createTrackbar(
        title_trackbar_kernel_size, title_erosion_window, 0, max_kernel_size, erosion
    )
    cv.namedWindow(title_dilation_window)
    cv.createTrackbar(
        title_trackbar_element_shape, title_dilation_window, 0, max_elem, dilatation
    )
    cv.createTrackbar(
        title_trackbar_kernel_size,
        title_dilation_window,
        0,
        max_kernel_size,
        dilatation,
    )
    erosion(0)
    dilatation(0)
    cv.waitKey()


def erosion(val):
    erosion_size = cv.getTrackbarPos(title_trackbar_kernel_size, title_erosion_window)
    erosion_shape = morph_shape(
        cv.getTrackbarPos(title_trackbar_element_shape, title_erosion_window)
    )

    element = cv.getStructuringElement(
        erosion_shape,
        (2 * erosion_size + 1, 2 * erosion_size + 1),
        (erosion_size, erosion_size),
    )

    erosion_dst = cv.erode(src, element)
    cv.imshow(title_erosion_window, erosion_dst)


def dilatation(val):
    dilatation_size = cv.getTrackbarPos(
        title_trackbar_kernel_size, title_dilation_window
    )
    dilation_shape = morph_shape(
        cv.getTrackbarPos(title_trackbar_element_shape, title_dilation_window)
    )
    element = cv.getStructuringElement(
        dilation_shape,
        (2 * dilatation_size + 1, 2 * dilatation_size + 1),
        (dilatation_size, dilatation_size),
    )
    dilatation_dst = cv.dilate(src, element)
    cv.imshow(title_dilation_window, dilatation_dst)